<template>
<form @submit.prevent="submit">
  <div class="form-without-border">
    <div class="row">
      <div class="col">
        <input v-model="user" class="form-control" :placeholder="$t('user')">
      </div>
      <div class="col">
        <input type="password" v-model="pw" class="form-control" :placeholder="$t('pw')">
      </div>
      <div class="center">
        <input type="submit" @click="login" class="btn btn-outline-primary" :value="$t('login')">
      </div>
    </div>
  </div>
</form>
</template>

<script>
import APILogin from '@/api/login'
import custom from '@/shared/custom'
export default {
  name: 'LoginComponent',
  data () {
    return {
      user: null,
      pw: null
    }
  },
  methods: {
    login () {
      if (this.user === null || this.pw === null) {
        this.$alert(this.$t('empty-field'), this.$t('warning'), 'warning')
      } else {
        this.$store.commit('saveLoading', true)
        APILogin.login(this.user, this.pw).then(response => {
          this.$store.commit('saveLoading', false)
          if (response) {
            this.$store.commit('saveTokens', response)
            this.$store.commit('saveRoles', APILogin.getRoleFromToken(response.access_token))
            this.$alert(this.$t('connected'), this.$t('loading'), 'success')
            this.$store.commit('saveEmail', this.user)
            setTimeout(() => { this.$router.go() }, 500)
          } else {
            this.$alert(this.$t('bad-pw'), this.$t('error'), 'error')
          }
        }).catch(() => {
          this.$store.commit('saveLoading', false)
          this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
        })
      }
    }
  },
  mounted () {
    custom.getGoodItemAndColorIt(this.$route.path)
  }
}
</script>

<style scoped>
.form-without-border {
  margin: 30px 8% 0 8%;
  padding-bottom: 20px;
}
</style>
